Bug 1406712 (CVE-2016-9586)

Summary: CVE-2016-9586 curl: printf floating point buffer overflow
Product: [Other] Security Response Reporter: Andrej Nemec <anemec>
Component: vulnerabilityAssignee: Red Hat Product Security <security-response-team>
Status: NEW --- QA Contact:
Severity: low Docs Contact:
Priority: low    
Version: unspecifiedCC: bmcclain, bodavis, cfergeau, csutherl, dbhole, dblechte, eedri, erik-fedora, gzaronik, hannsj_uhl, hhorak, jclere, jorton, kanderso, kdudka, lgao, lsurette, luhliari, mbabacek, mgoldboi, michal.skrivanek, mike, myarboro, omajid, paul, rbalakri, rh-spice-bugs, rwagner, sardella, sbonazzo, sherold, srevivo, twalsh, weli, ykaul, ylavi
Target Milestone: ---Keywords: Reopened, Security
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard: impact=low,public=20161221,reported=20161213,source=distros,cvss2=2.6/AV:N/AC:H/Au:N/C:N/I:N/A:P,cvss3=5.9/CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H,cwe=CWE-122,rhel-5/curl=wontfix,rhel-6/curl=wontfix,rhel-7/curl=wontfix,jbews-3/curl=notaffected,rhev-m-3/mingw-virt-viewer=wontfix,fedora-all/curl=affected,fedora-all/mingw-curl=affected,epel-7/mingw-curl=affected,dotnet-1.0/rh-dotnetcore10-curl=new,dotnet-1.1/rh-dotnetcore11-curl=new,dotnet-2.0/rh-dotnet20-curl=new,dotnet-2.1/rh-dotnet21-curl=new,rhscl-3/httpd24-curl=affected
Fixed In Version: curl 7.52.0 Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2017-01-18 23:58:16 UTC Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
Bug Depends On: 1406718, 1406716, 1406717    
Bug Blocks: 1406719    

Description Andrej Nemec 2016-12-21 10:11:52 UTC
libcurl's implementation of the printf() functions triggers a buffer overflow
when doing a large floating point output. The bug occurs when the conversion
outputs more than 255 bytes.

The flaw happens because the floating point conversion is using system
functions without the correct boundary checks.

The functions have been documented as deprecated for a long time and users are
discouraged from using them in "new programs" as they are planned to get
removed at a future point. But as the functions are present and there's
nothing preventing users from using them, we expect there to be a certain
amount of existing users in the wild.

If there are any application that accepts a format string from the outside
without necessary input filtering, it could allow remote attacks.

This flaw does not exist in the command line tool.

We are not aware of any exploit of this flaw.

References:

http://seclists.org/oss-sec/2016/q4/719

External References:

https://curl.haxx.se/docs/adv_20161221A.html

Upstream patch:

https://curl.haxx.se/CVE-2016-9586.patch

Comment 1 Andrej Nemec 2016-12-21 10:12:18 UTC
Acknowledgments:

Name: the Curl project

Comment 2 Andrej Nemec 2016-12-21 10:21:36 UTC
Created curl tracking bugs for this issue:

Affects: fedora-all [bug 1406716]

Comment 3 Andrej Nemec 2016-12-21 10:21:54 UTC
Created mingw-curl tracking bugs for this issue:

Affects: fedora-all [bug 1406717]
Affects: epel-7 [bug 1406718]

Comment 4 Doran Moppert 2016-12-22 03:55:27 UTC
This flaw is present in the curl_*printf (curlx_*printf) family of functions, which are not used by curl but are exposed from libcurl.  I can't find any of these functions being used across Enterprise Linux.

To be exposed, third-party code would need to be using these long-deprecated functions, with a floating-point specifier and user-controlled (floating-point) input.  The overflow itself is of a 256-byte stack-allocated buffer, when the decimal expansion of the float exceeds that by up to 70 bytes.  Beyond about 16 digits for a double, the decimal expansion is effectively random so the attacker has very little control over precisely what bytes are written.  I think the chance of ACE can be discounted here.

Comment 5 Kamil Dudka 2016-12-23 08:48:28 UTC
upstream commit:

https://github.com/curl/curl/commit/curl-7_51_0-162-g3ab3c16

Comment 6 errata-xmlrpc 2018-11-13 08:34:08 UTC
This issue has been addressed in the following products:

  Red Hat Software Collections for Red Hat Enterprise Linux 6
  Red Hat Software Collections for Red Hat Enterprise Linux 7
  Red Hat Software Collections for Red Hat Enterprise Linux 7.4 EUS
  Red Hat Software Collections for Red Hat Enterprise Linux 7.5 EUS
  Red Hat Software Collections for Red Hat Enterprise Linux 7.6 EUS

Via RHSA-2018:3558 https://access.redhat.com/errata/RHSA-2018:3558